#!/usr/bin/python
# -*- coding: utf-8 -*-

###############################################################
# nomsn - Bot jabber à utiliser avec une passerelle msn       #
# Version 0.3.2                                               #
# Largement basé sur le script de Florian Birée :             #
#   http://filyb.info/dotclear/index.php/2006/01/28/212-nomsn #
#   Copyright Florian Birée, 2006                             #
# Modifier par Jonas pour plus de fonctionnalitée et          #
#   amélioration du support de l'UTF-8                        #
#   http://jonas.tuxfamily.org/?2007/01/14/46-nomsn           #
# Sous licence GNU GPL (http://www.gnu.org/licenses/gpl.html) #
###############################################################

###Importation des modules
import sys
import xmpp
import os
import time
import string

#/Personalisation du bot : \_________________________________________________________________________________
#############################################################################################################
#votre pseudo
pseudo = "votre_pseudo"
#URL d'explication sur l'utilisation de jabber
explicurl = "http://votre_site/votre_page"
#Texte affiché par le bot par la commande contact (le %s ajoute l'url d'explication sur jabber)
contactText = u"""
Messagerie instantanée (explications : %s ):
- Jabber : pseudo@serveur.org
"""%explicurl
#JID du propriétaire du bot (le seul qui peut administrer le bot
jidOwner = 'pseudo@serveur.org/resource'
#   Commande administrateur :
#       fermer: arreter le bot
#       log:    Consulter le log (messages laisser pour les visiteurs)
#       rmlog:  Effacer le fichier de log

# Chemin vers le fichier de log (par defaut enregistre dans /home/user/.nomsnlog)
PathFileLog = os.getenv("HOME") + "/.nomsnlog"
#____________________________________________________________________________________________________________
#############################################################################################################

__author__ = "Florian Birée puis modifé par Jonas Fourquier"
__version__ = "0.3.2"
copyright = "Florian Birée & Jonas Fourquier, 2007, sous licence GNU/GPL"

###Changlog :
#version 0.2.0 :
#   o enregistrement des messages de l'extérieur dans ~/.nomsnlog
#   o déplacement des variables de contexte en hautdu script
#version 0.3.0 (modification Jonas Fourquier):
#   o Amélioration du support de l'UTF-8
#   o Consoltation et affacement du log via jabber pour l'administrateur
#   o Ajout de 2-3 réponse gadjet
#version 0.3.1 :
#   o Renomage du programme en "nomsn" et ajout d'un lien vers les conditions de la GNU GPL
#version 0.3.2 :
#   o Le fichier de log n'enregistre plus les messages de l'administrateur
#   o Lecture du fichier de log à distance améliorée


commands={}
i18n={'fr':{},'en':{}}
########################### Commandes ##################################
i18n['fr']['AIDE']="Robot d'informations sur jabber.\nCommandes disponibles : %s"
i18n['en']['AIDE']="Jabber info bot.\nAvailable commands: %s"
def aideHandler(user,command,args,mess):
    lst=commands.keys()
    lst.sort()
    return "AIDE",', '.join(lst)

i18n['en']['EMPTY']="%s"
i18n['fr']['CONTACT']='Contact : %s'
i18n['en']['CONTACT']='Contact : %s'
def contactHandler(user,command,args,mess):
    return "CONTACT",contactText

i18n['fr']['APROPOS']='A propos de : %s'
def aproposHandler(user,command,args,mess):
    return "APROPOS","ce robot jabber à été programmé en python avec xmpppy. Copyright %s.\nPage Web : http://jonas.tuxfamily.org/?2007/01/14/46-nomsn\n\nLes citations sont fournies par le programme Fortune.\n"%copyright

# Réponse gadjet à "Salut ..."
def salutHandler(user,command,args,mess):
    return "Salut comment vas tu ?"

# Réponse gadjet à "Bien ..."
def bienHandler(user,command,args,mess):
    return "Très bien, en faite quand on est composé de puces et de transistors on va rarement mal :p."

# Réponse gadjet à "quoi ..."
def quoiHandler(user,command,args,mess):
    import commands
    cit = commands.getoutput('fortune')
    return "Ben oui tu es train de parler à un robot car " + pseudo + " a décidé d'arrêter d'utiliser ce msn de ... (plus d'info : %s) par contre je peux te balancer des supers citation :\n %s\n\n Pour plus d'info tape \"aide\""%(explicurl,cit)

i18n['fr']['CITATION']='Citation :\n%s'
def citationHandler(user,command,args,mess):
    import commands
    cit = commands.getoutput('fortune')
    #cit = cit.encode("ascii","replace")
    return "CITATION", cit

i18n['fr']['FERMER']='Fermer : %s'
def fermerHandler(user,command,args,mess):
    if user == jidOwner :
        sys.exit()
    ret = "Cette commande est réservée à l'administrateur du Bot./n Pour quitter cette discussion, fermez simplement votre fenètre ;-)"%jidOwner
    return "FERMER",ret

def logHandler(user,command,args,mess):
    if user == jidOwner :
        #lecture du log
        try:
            log = open(PathFileLog,"r")
            text = "Contenu du log :\n" + log.read() + "\n\nTapez \"rmlog\" pour effacer le log."
            log.close
        except:
            text = "Il n'y a aucun message"
        return text
    else:
        return "Cette commande est réservée à l'administrateur du Bot"

def rmlogHandler(user,command,args,mess):
    if user == jidOwner :
        os.remove(PathFileLog)
        return "Fichier de log effacé"
    else:
        return "Cette commande est réservée à l'administrateur du Bot"

########################### user handlers stop ###################################
############################ bot logic start #####################################
i18n['en']["UNKNOWN COMMAND"]='Unknown command "%s". Try "help"'
i18n['fr']["UNKNOWN COMMAND"]='J\'ai decide d\'arreter d\'utiliser MSN Messenger. Si vous voulez me parler par messagerie instantanee, vous pouvez le faire en utilisant le reseau Jabber (Identifiant : ' + jidOwner + '). Pour plus de details, voyez cette page web : ' + explicurl + '\n\nCe message est un message automatique. La commande que vous avez envoye a ce robot ("%s") est inconnue. Entrez "Aide" pour connaitre les commandes possibles.'
i18n['fr']["UNKNOWN USER"]="Je ne vous connait pas. Enregistrez-vous s'il vous plait."
i18n['en']["UNKNOWN USER"]="I do not know you. Register first."


def messageCB(conn,mess):
    text=mess.getBody()
    user=mess.getFrom()
    user.lang='fr'      # dup
    if text.find(' ')+1: command,args=text.split(' ',1)
    else: command,args=text,''
    cmd=command.lower()

    #ajouter au log
    if user != jidOwner :
        log = open(PathFileLog,"a")
        log.write(time.asctime(time.localtime()) + " :: " + str(user) + " :: " + text.encode('utf-8') + "\n")
        log.close
    #fin log
    if commands.has_key(cmd): reply=commands[cmd](user,command,args,mess)
    else: reply=("UNKNOWN COMMAND",cmd)

    if type(reply)==type(()):
        key,args=reply
        if i18n[user.lang].has_key(key): pat=i18n[user.lang][key]
        elif i18n['en'].has_key(key): pat=i18n['en'][key]
        else: pat="%s"
        if type(pat)==type(''): reply=pat%args
        else: reply=pat(**args)
    else:
        try: reply=i18n[user.lang][reply]
        except KeyError:
            try: reply=i18n['en'][reply]
            except KeyError: pass
    if reply: conn.send(xmpp.Message(mess.getFrom(),reply))

for i in globals().keys():
    if i[-7:]=='Handler' and i[:-7].lower()==i[:-7]: commands[i[:-7]]=globals()[i]

############################# bot logic stop #####################################

def StepOn(conn):
    try:
        conn.Process(1)
    except KeyboardInterrupt: return 0
    return 1

def GoOn(conn):
    while StepOn(conn): pass

if len(sys.argv)<3:
    print "Usage: bot.py username@server.net password"
else:
    jid=xmpp.JID(sys.argv[1])
    user,server,password=jid.getNode(),jid.getDomain(),sys.argv[2]

    conn=xmpp.Client(server)#,debug=[])
    conres=conn.connect()
    if not conres:
        print "Unable to connect to server %s!"%server
        sys.exit(1)
    if conres<>'tls':
        print "Warning: unable to estabilish secure connection - TLS failed!"
    authres=conn.auth(user,password)
    if not authres:
        print "Unable to authorize on %s - check login/password."%server
        sys.exit(1)
    if authres<>'sasl':
        print "Warning: unable to perform SASL auth os %s. Old authentication method used!"%server
    conn.RegisterHandler('message',messageCB)
    conn.sendInitPresence()
    print "Bot started."
    GoOn(conn)
